//---------------------------------------------------------------------------
//   . 2003
//      
//     .  2.     .
//   http://bcdev.narod.ru
//   e-mail:yerm@mail.ru
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <IStreams.hpp>
#include "FormExpert.h"
#pragma package(smart_init)
const int nUnit_h = 100;
const int nUnit_cpp = 200;
const int nUnit_dfm = 300;
const AnsiString AncestorIdent = "StorageForm";

//---------------------------------------------------------------------------
__fastcall TStorageFormExpert::TStorageFormExpert()
        : TIExpert()
{
        hIcon = LoadIcon(HInstance, "STORAGEFORMEXPERT");
}
//---------------------------------------------------------------------------
AnsiString __stdcall TStorageFormExpert::GetName(void)
{
        return "StorageForm Expert";
}
//---------------------------------------------------------------------------
AnsiString __stdcall TStorageFormExpert::GetAuthor(void)
{
        return "Vyacheslav Yermolayev";
}
//---------------------------------------------------------------------------
AnsiString __stdcall TStorageFormExpert::GetComment(void)
{
        return "Creating new StorageForm in my projects";
}
//---------------------------------------------------------------------------
AnsiString __stdcall TStorageFormExpert::GetPage(void)
{
          return "StorageForm";
}

//---------------------------------------------------------------------------
HICON __stdcall TStorageFormExpert::GetGlyph(void)
{
        return hIcon;
}
//---------------------------------------------------------------------------
TExpertStyle __stdcall TStorageFormExpert::GetStyle(void)
{
        return esForm;
}
//---------------------------------------------------------------------------
TExpertState __stdcall TStorageFormExpert::GetState()
{
        return TExpertState() << esEnabled;
};
//---------------------------------------------------------------------------
AnsiString __stdcall TStorageFormExpert::GetMenuText()
{
        return "";
}
//---------------------------------------------------------------------------
AnsiString __stdcall TStorageFormExpert::GetIDString()
{
        return "MyFirm.StorageFormExpert";
};
//---------------------------------------------------------------------------
void __stdcall TStorageFormExpert::Execute(void)
{
  if (!ToolServices) exit(1);
  std::auto_ptr<TFileName> FileName(new TFileName);
  AnsiString   UnitIdent;
  AnsiString   FormIdent;
  TIMemoryStream* imsHdr;
  TIMemoryStream* imsCpp;
  TIMemoryStream* imsDfm;
  try
  {
   if (ToolServices->GetNewModuleName(UnitIdent, *FileName))
   {
    FormIdent = AncestorIdent + UnitIdent.SubString(5, 255);
    std::auto_ptr<TStringStream> ssHdr( new TStringStream(
      FmtLoadStr(nUnit_h,ARRAYOFCONST((UnitIdent,FormIdent,AncestorIdent)))));
    std::auto_ptr<TMemoryStream> msHdr(new TMemoryStream());
    msHdr->LoadFromStream(ssHdr.get());
    imsHdr = new TIMemoryStream(msHdr.get(),soReference);
    try
    {
     std::auto_ptr<TStringStream> ssCpp( new TStringStream(
       FmtLoadStr(nUnit_cpp,ARRAYOFCONST((UnitIdent,FormIdent,AncestorIdent)))));
     std::auto_ptr<TMemoryStream> msCpp(new TMemoryStream());
     msCpp->LoadFromStream(ssCpp.get());
     imsCpp = new TIMemoryStream(msCpp.get(),soReference);
     try
     {
      std::auto_ptr<TStringStream> ssDfm( new TStringStream(
                    FmtLoadStr(nUnit_dfm,ARRAYOFCONST((FormIdent)))));
      std::auto_ptr<TMemoryStream> msDfm(new TMemoryStream());
      ObjectTextToResource(ssDfm.get(), msDfm.get());
      imsDfm = new TIMemoryStream(msDfm.get(),soReference);
      try
      {
       TCreateModuleFlags CreateFlags;
       CreateFlags << cmAddToProject << cmShowSource
                             << cmShowForm << cmUnNamed
                             << cmMarkModified;
       ToolServices->CreateCppModule(*FileName, "", "", "",
                                  (IStream*)(*imsHdr),
                                  (IStream*)(*imsCpp),
                                  (IStream*)(*imsDfm),
                                  CreateFlags);
      }
      catch(...)
      {
       delete imsDfm;
       throw;
      }
     }
     catch(...)
     {
      delete imsCpp;
      throw;
     }
    }
    catch(...)
    {
     delete imsHdr;
     throw;
    }
  }
 }
 catch(...){ ToolServices->RaiseException(ReleaseException());}
}
//---------------------------------------------------------------------------



